]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
e75f93b3dcab73a701559d006b72f958937ebf57
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # Save STDOUT to fd 6 and STDERR to fd 7.
59 exec 6>&1 7>&2
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
61 BASH_XTRACEFD=7
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
63
64 # Keep the original TERM for say_color and test_emacs
65 ORIGINAL_TERM=$TERM
66
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
70 case ${TERM-} in
71         '' | dumb | unknown )
72                 SMART_TERM=vt100 ;;
73         *)
74                 SMART_TERM=$TERM ;;
75 esac
76
77 # For repeatability, reset the environment to known value.
78 LANG=C
79 LC_ALL=C
80 PAGER=cat
81 TZ=UTC
82 TERM=dumb
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
88     exit 1
89 fi
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 # For emacsclient
103 unset ALTERNATE_EDITOR
104
105 add_gnupg_home ()
106 {
107     local output
108     [ -d ${GNUPGHOME} ] && return
109     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110     at_exit_function _gnupg_exit
111     mkdir -m 0700 "$GNUPGHOME"
112     gpg --no-tty --import <$TEST_DIRECTORY/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113     test_debug "cat $GNUPGHOME/import.log"
114     if (gpg --quick-random --version >/dev/null 2>&1) ; then
115         echo quick-random >> "$GNUPGHOME"/gpg.conf
116     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
118     fi
119     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
120 }
121
122 # Each test should start with something like this, after copyright notices:
123 #
124 # test_description='Description of this test...
125 # This test checks if command xyzzy does the right thing...
126 # '
127 # . ./test-lib.sh || exit 1
128
129 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
130                 TERM=$ORIGINAL_TERM &&
131                 export TERM &&
132                 [ -t 1 ] &&
133                 tput bold >/dev/null 2>&1 &&
134                 tput setaf 1 >/dev/null 2>&1 &&
135                 tput sgr0 >/dev/null 2>&1
136         ) &&
137         color=t
138
139 while test "$#" -ne 0
140 do
141         case "$1" in
142         -d|--debug)
143                 debug=t; shift ;;
144         -i|--immediate)
145                 immediate=t; shift ;;
146         -h|--help)
147                 help=t; shift ;;
148         -v|--verbose)
149                 verbose=t; shift ;;
150         -q|--quiet)
151                 quiet=t; shift ;;
152         --with-dashes)
153                 with_dashes=t; shift ;;
154         --no-color)
155                 color=; shift ;;
156         --no-python)
157                 # noop now...
158                 shift ;;
159         --valgrind)
160                 valgrind=t; verbose=t; shift ;;
161         --tee)
162                 shift ;; # was handled already
163         --root=*)
164                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
165                 shift ;;
166         *)
167                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
168         esac
169 done
170
171 if test -n "$debug"; then
172     print_subtest () {
173         printf " %-4s" "[$((test_count - 1))]"
174     }
175 else
176     print_subtest () {
177         true
178     }
179 fi
180
181 if test -n "$color"; then
182         say_color () {
183                 (
184                 TERM=$ORIGINAL_TERM
185                 export TERM
186                 case "$1" in
187                         error) tput bold; tput setaf 1;; # bold red
188                         skip)  tput bold; tput setaf 2;; # bold green
189                         pass)  tput setaf 2;;            # green
190                         info)  tput setaf 3;;            # brown
191                         *) test -n "$quiet" && return;;
192                 esac
193                 shift
194                 printf " "
195                 printf "$@"
196                 tput sgr0
197                 print_subtest
198                 )
199         }
200 else
201         say_color() {
202                 test -z "$1" && test -n "$quiet" && return
203                 shift
204                 printf " "
205                 printf "$@"
206                 print_subtest
207         }
208 fi
209
210 error () {
211         say_color error "error: $*\n"
212         GIT_EXIT_OK=t
213         exit 1
214 }
215
216 say () {
217         say_color info "$*"
218 }
219
220 test "${test_description}" != "" ||
221 error "Test script did not set test_description."
222
223 if test "$help" = "t"
224 then
225         echo "Tests ${test_description}"
226         exit 0
227 fi
228
229 test_description_printed=
230 print_test_description ()
231 {
232         test -z "$test_description_printed" || return 0
233         echo
234         echo $this_test: "Testing ${test_description}"
235         test_description_printed=1
236 }
237 if [ -z "$NOTMUCH_TEST_QUIET" ]
238 then
239         print_test_description
240 fi
241
242 test_failure=0
243 test_count=0
244 test_fixed=0
245 test_broken=0
246 test_success=0
247
248 declare -a _exit_functions=()
249
250 at_exit_function () {
251         _exit_functions=($1 ${_exit_functions[@]/$1})
252 }
253
254 rm_exit_function () {
255         _exit_functions=(${_exit_functions[@]/$1})
256 }
257
258 _exit_common () {
259         code=$?
260         trap - EXIT
261         set +ex
262         for _fn in ${_exit_functions[@]}; do $_fn; done
263         rm -rf "$TEST_TMPDIR"
264 }
265
266 trap_exit () {
267         _exit_common
268         if test -n "$GIT_EXIT_OK"
269         then
270                 exit $code
271         else
272                 exec >&6
273                 say_color error '%-6s' FATAL
274                 echo " $test_subtest_name"
275                 echo
276                 echo "Unexpected exit while executing $0. Exit code $code."
277                 exit 1
278         fi
279 }
280
281 trap_signal () {
282         _exit_common
283         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
284         exit $code
285 }
286
287 die () {
288         _exit_common
289         exec >&6
290         say_color error '%-6s' FATAL
291         echo " $*"
292         echo
293         echo "Unexpected exit while executing $0."
294         exit 1
295 }
296
297 GIT_EXIT_OK=
298 # Note: TEST_TMPDIR *NOT* exported!
299 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
300 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
301 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
302 trap 'trap_exit' EXIT
303 trap 'trap_signal' HUP INT TERM
304
305 # Deliver a message with emacs and add it to the database
306 #
307 # Uses emacs to generate and deliver a message to the mail store.
308 # Accepts arbitrary extra emacs/elisp functions to modify the message
309 # before sending, which is useful to doing things like attaching files
310 # to the message and encrypting/signing.
311 emacs_deliver_message ()
312 {
313     local subject="$1"
314     local body="$2"
315     shift 2
316     # before we can send a message, we have to prepare the FCC maildir
317     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
318     # eval'ing smtp-dummy --background will set smtp_dummy_pid
319     smtp_dummy_pid=
320     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
321     test -n "$smtp_dummy_pid" || return 1
322
323     test_emacs \
324         "(let ((message-send-mail-function 'message-smtpmail-send-it)
325                (mail-host-address \"example.com\")
326                (smtpmail-smtp-server \"localhost\")
327                (smtpmail-smtp-service \"25025\"))
328            (notmuch-mua-mail)
329            (message-goto-to)
330            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
331            (message-goto-subject)
332            (insert \"${subject}\")
333            (message-goto-body)
334            (insert \"${body}\")
335            $@
336            (notmuch-mua-send-and-exit))"
337
338     # In case message was sent properly, client waits for confirmation
339     # before exiting and resuming control here; therefore making sure
340     # that server exits by sending (KILL) signal to it is safe.
341     kill -9 $smtp_dummy_pid
342     notmuch new >/dev/null
343 }
344
345 # Pretend to deliver a message with emacs. Really save it to a file
346 # and add it to the database
347 #
348 # Uses emacs to generate and deliver a message to the mail store.
349 # Accepts arbitrary extra emacs/elisp functions to modify the message
350 # before sending, which is useful to doing things like attaching files
351 # to the message and encrypting/signing.
352 emacs_fcc_message ()
353 {
354     local subject="$1"
355     local body="$2"
356     shift 2
357     # before we can send a message, we have to prepare the FCC maildir
358     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
359
360     test_emacs \
361         "(let ((message-send-mail-function (lambda () t))
362                (mail-host-address \"example.com\"))
363            (notmuch-mua-mail)
364            (message-goto-to)
365            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
366            (message-goto-subject)
367            (insert \"${subject}\")
368            (message-goto-body)
369            (insert \"${body}\")
370            $@
371            (notmuch-mua-send-and-exit))" || return 1
372     notmuch new >/dev/null
373 }
374
375 # Add an existing, fixed corpus of email to the database.
376 #
377 # $1 is the corpus dir under corpora to add, using "default" if unset.
378 #
379 # The default corpus is based on about 50 messages from early in the
380 # history of the notmuch mailing list, which allows for reliably
381 # testing commands that need to operate on a not-totally-trivial
382 # number of messages.
383 add_email_corpus ()
384 {
385     corpus=${1:-default}
386
387     rm -rf ${MAIL_DIR}
388     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
389         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
390     else
391         cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
392         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
393         mkdir -p $TEST_DIRECTORY/corpora.mail
394         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
395     fi
396 }
397
398 test_begin_subtest ()
399 {
400     if [ -n "$inside_subtest" ]; then
401         exec 1>&6 2>&7          # Restore stdout and stderr
402         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
403     fi
404     test_subtest_name="$1"
405     test_reset_state_
406     # Redirect test output to the previously prepared file descriptors
407     # 3 and 4 (see below)
408     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
409     exec >&3 2>&4
410     inside_subtest=t
411 }
412
413 # Pass test if two arguments match
414 #
415 # Note: Unlike all other test_expect_* functions, this function does
416 # not accept a test name. Instead, the caller should call
417 # test_begin_subtest before calling this function in order to set the
418 # name.
419 test_expect_equal ()
420 {
421         exec 1>&6 2>&7          # Restore stdout and stderr
422         if [ -z "$inside_subtest" ]; then
423                 error "bug in the test script: test_expect_equal without test_begin_subtest"
424         fi
425         inside_subtest=
426         test "$#" = 2 ||
427         error "bug in the test script: not 2 parameters to test_expect_equal"
428
429         output="$1"
430         expected="$2"
431         if ! test_skip "$test_subtest_name"
432         then
433                 if [ "$output" = "$expected" ]; then
434                         test_ok_
435                 else
436                         testname=$this_test.$test_count
437                         echo "$expected" > $testname.expected
438                         echo "$output" > $testname.output
439                         test_failure_ "$(diff -u $testname.expected $testname.output)"
440                 fi
441     fi
442 }
443
444 # Like test_expect_equal, but takes two filenames.
445 test_expect_equal_file ()
446 {
447         exec 1>&6 2>&7          # Restore stdout and stderr
448         if [ -z "$inside_subtest" ]; then
449                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
450         fi
451         inside_subtest=
452         test "$#" = 2 ||
453         error "bug in the test script: not 2 parameters to test_expect_equal_file"
454
455         file1="$1"
456         file2="$2"
457         if ! test_skip "$test_subtest_name"
458         then
459                 if diff -q "$file1" "$file2" >/dev/null ; then
460                         test_ok_
461                 else
462                         testname=$this_test.$test_count
463                         basename1=`basename "$file1"`
464                         basename2=`basename "$file2"`
465                         cp "$file1" "$testname.$basename1"
466                         cp "$file2" "$testname.$basename2"
467                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
468                 fi
469     fi
470 }
471
472 # Like test_expect_equal, but arguments are JSON expressions to be
473 # canonicalized before diff'ing.  If an argument cannot be parsed, it
474 # is used unchanged so that there's something to diff against.
475 test_expect_equal_json () {
476     # The test suite forces LC_ALL=C, but this causes Python 3 to
477     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
478     # override Python's stdio encoding defaults.
479     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
480     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
481         || echo "$1")
482     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
483         || echo "$2")
484     shift 2
485     test_expect_equal "$output" "$expected" "$@"
486 }
487
488 # Sort the top-level list of JSON data from stdin.
489 test_sort_json () {
490     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
491         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
492 }
493
494 test_emacs_expect_t () {
495         test "$#" = 1 ||
496         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
497         if [ -z "$inside_subtest" ]; then
498                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
499         fi
500
501         # Run the test.
502         if ! test_skip "$test_subtest_name"
503         then
504                 test_emacs "(notmuch-test-run $1)" >/dev/null
505
506                 # Restore state after the test.
507                 exec 1>&6 2>&7          # Restore stdout and stderr
508                 inside_subtest=
509
510                 # Report success/failure.
511                 result=$(cat OUTPUT)
512                 if [ "$result" = t ]
513                 then
514                         test_ok_
515                 else
516                         test_failure_ "${result}"
517                 fi
518         else
519                 # Restore state after the (non) test.
520                 exec 1>&6 2>&7          # Restore stdout and stderr
521                 inside_subtest=
522         fi
523 }
524
525 NOTMUCH_NEW ()
526 {
527     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
528 }
529
530 NOTMUCH_DUMP_TAGS ()
531 {
532     # this relies on the default format being batch-tag, otherwise some tests will break
533     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
534 }
535
536 notmuch_drop_mail_headers ()
537 {
538     $NOTMUCH_PYTHON -c '
539 import email, sys
540 msg = email.message_from_file(sys.stdin)
541 for hdr in sys.argv[1:]: del msg[hdr]
542 print(msg.as_string(False))
543 ' "$@"
544 }
545
546 notmuch_search_sanitize ()
547 {
548     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
549 }
550
551 notmuch_search_files_sanitize ()
552 {
553     notmuch_dir_sanitize
554 }
555
556 notmuch_dir_sanitize ()
557 {
558     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
559 }
560
561 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
562 notmuch_show_sanitize ()
563 {
564     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
565 }
566 notmuch_show_sanitize_all ()
567 {
568     sed \
569         -e 's| filename:.*| filename:XXXXX|' \
570         -e 's| id:[^ ]* | id:XXXXX |' | \
571         notmuch_date_sanitize
572 }
573
574 notmuch_json_show_sanitize ()
575 {
576     sed \
577         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
578         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
579         -e 's|"filename": "signature.asc",||g' \
580         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
581         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
582         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
583 }
584
585 notmuch_emacs_error_sanitize ()
586 {
587     local command=$1
588     shift
589     for file in "$@"; do
590         echo "=== $file ==="
591         cat "$file"
592     done | sed  \
593         -e 's/^\[.*\]$/[XXX]/' \
594         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
595 }
596
597 notmuch_date_sanitize ()
598 {
599     sed \
600         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
601 }
602
603 notmuch_uuid_sanitize ()
604 {
605     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
606 }
607
608 notmuch_built_with_sanitize ()
609 {
610     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
611 }
612
613 notmuch_config_sanitize ()
614 {
615     notmuch_dir_sanitize | notmuch_built_with_sanitize
616 }
617
618 # End of notmuch helper functions
619
620 # Use test_set_prereq to tell that a particular prerequisite is available.
621 #
622 # The prerequisite can later be checked for by using test_have_prereq.
623 #
624 # The single parameter is the prerequisite tag (a simple word, in all
625 # capital letters by convention).
626
627 test_set_prereq () {
628         satisfied="$satisfied$1 "
629 }
630 satisfied=" "
631
632 test_have_prereq () {
633         case $satisfied in
634         *" $1 "*)
635                 : yes, have it ;;
636         *)
637                 ! : nope ;;
638         esac
639 }
640
641 declare -A test_missing_external_prereq_
642 declare -A test_subtest_missing_external_prereq_
643
644 # declare prerequisite for the given external binary
645 test_declare_external_prereq () {
646         binary="$1"
647         test "$#" = 2 && name=$2 || name="$binary(1)"
648
649         if ! hash $binary 2>/dev/null; then
650                 test_missing_external_prereq_["${binary}"]=t
651                 eval "
652 $binary () {
653         test_subtest_missing_external_prereq_[\"${name}\"]=t
654         false
655 }"
656         fi
657 }
658
659 # Explicitly require external prerequisite.  Useful when binary is
660 # called indirectly (e.g. from emacs).
661 # Returns success if dependency is available, failure otherwise.
662 test_require_external_prereq () {
663         binary="$1"
664         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
665                 # dependency is missing, call the replacement function to note it
666                 eval "$binary"
667         else
668                 true
669         fi
670 }
671
672 # You are not expected to call test_ok_ and test_failure_ directly, use
673 # the text_expect_* functions instead.
674
675 test_ok_ () {
676         if test "$test_subtest_known_broken_" = "t"; then
677                 test_known_broken_ok_
678                 return
679         fi
680         test_success=$(($test_success + 1))
681         if test -n "$NOTMUCH_TEST_QUIET"; then
682                 return 0
683         fi
684         say_color pass "%-6s" "PASS"
685         echo " $test_subtest_name"
686 }
687
688 test_failure_ () {
689         print_test_description
690         if test "$test_subtest_known_broken_" = "t"; then
691                 test_known_broken_failure_ "$@"
692                 return
693         fi
694         test_failure=$(($test_failure + 1))
695         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
696         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
697         return 1
698 }
699
700 test_failure_message_ () {
701         say_color error "%-6s" "$1"
702         echo " $2"
703         shift 2
704         if [ "$#" != "0" ]; then
705                 echo "$@" | sed -e 's/^/        /'
706         fi
707         if test "$verbose" != "t"; then cat test.output; fi
708 }
709
710 test_known_broken_ok_ () {
711         test_reset_state_
712         test_fixed=$(($test_fixed+1))
713         say_color pass "%-6s" "FIXED"
714         echo " $test_subtest_name"
715 }
716
717 test_known_broken_failure_ () {
718         test_reset_state_
719         test_broken=$(($test_broken+1))
720         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
721                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
722         else
723                 test_failure_message_ "BROKEN" "$test_subtest_name"
724         fi
725         return 1
726 }
727
728 test_debug () {
729         test "$debug" = "" || eval "$1"
730 }
731
732 test_run_ () {
733         test_cleanup=:
734         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
735         eval >&3 2>&4 "$1"
736         eval_ret=$?
737         eval >&3 2>&4 "$test_cleanup"
738         return 0
739 }
740
741 test_skip () {
742         test_count=$(($test_count+1))
743         to_skip=
744         for skp in $NOTMUCH_SKIP_TESTS
745         do
746                 case $this_test.$test_count in
747                 $skp)
748                         to_skip=t
749                         break
750                 esac
751                 case $this_test_bare.$test_count in
752                 $skp)
753                         to_skip=t
754                         break
755                 esac
756         done
757         case "$to_skip" in
758         t)
759                 test_report_skip_ "$@"
760                 ;;
761         *)
762                 test_check_missing_external_prereqs_ "$@"
763                 ;;
764         esac
765 }
766
767 test_check_missing_external_prereqs_ () {
768         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
769                 say_color skip >&1 "missing prerequisites: "
770                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
771                 test_report_skip_ "$@"
772         else
773                 false
774         fi
775 }
776
777 test_report_skip_ () {
778         test_reset_state_
779         say_color skip >&3 "skipping test:"
780         echo " $@" >&3
781         say_color skip "%-6s" "SKIP"
782         echo " $1"
783 }
784
785 test_subtest_known_broken () {
786         test_subtest_known_broken_=t
787 }
788
789 test_expect_success () {
790         exec 1>&6 2>&7          # Restore stdout and stderr
791         if [ -z "$inside_subtest" ]; then
792                 error "bug in the test script: test_expect_success without test_begin_subtest"
793         fi
794         inside_subtest=
795         test "$#" = 1 ||
796         error "bug in the test script: not 1 parameters to test_expect_success"
797
798         if ! test_skip "$test_subtest_name"
799         then
800                 test_run_ "$1"
801                 run_ret="$?"
802                 # test_run_ may update missing external prerequisites
803                 test_check_missing_external_prereqs_ "$@" ||
804                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
805                 then
806                         test_ok_
807                 else
808                         test_failure_ "$1"
809                 fi
810         fi
811 }
812
813 test_expect_code () {
814         exec 1>&6 2>&7          # Restore stdout and stderr
815         if [ -z "$inside_subtest" ]; then
816                 error "bug in the test script: test_expect_code without test_begin_subtest"
817         fi
818         inside_subtest=
819         test "$#" = 2 ||
820         error "bug in the test script: not 2 parameters to test_expect_code"
821
822         if ! test_skip "$test_subtest_name"
823         then
824                 test_run_ "$2"
825                 run_ret="$?"
826                 # test_run_ may update missing external prerequisites,
827                 test_check_missing_external_prereqs_ "$@" ||
828                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
829                 then
830                         test_ok_
831                 else
832                         test_failure_ "exit code $eval_ret, expected $1" "$2"
833                 fi
834         fi
835 }
836
837 # This is not among top-level (test_expect_success)
838 # but is a prefix that can be used in the test script, like:
839 #
840 #       test_expect_success 'complain and die' '
841 #           do something &&
842 #           do something else &&
843 #           test_must_fail git checkout ../outerspace
844 #       '
845 #
846 # Writing this as "! git checkout ../outerspace" is wrong, because
847 # the failure could be due to a segv.  We want a controlled failure.
848
849 test_must_fail () {
850         "$@"
851         test $? -gt 0 -a $? -le 129 -o $? -gt 192
852 }
853
854 # test_cmp is a helper function to compare actual and expected output.
855 # You can use it like:
856 #
857 #       test_expect_success 'foo works' '
858 #               echo expected >expected &&
859 #               foo >actual &&
860 #               test_cmp expected actual
861 #       '
862 #
863 # This could be written as either "cmp" or "diff -u", but:
864 # - cmp's output is not nearly as easy to read as diff -u
865 # - not all diff versions understand "-u"
866
867 test_cmp() {
868         $GIT_TEST_CMP "$@"
869 }
870
871 # This function can be used to schedule some commands to be run
872 # unconditionally at the end of the test to restore sanity:
873 #
874 #       test_expect_success 'test core.capslock' '
875 #               git config core.capslock true &&
876 #               test_when_finished "git config --unset core.capslock" &&
877 #               hello world
878 #       '
879 #
880 # That would be roughly equivalent to
881 #
882 #       test_expect_success 'test core.capslock' '
883 #               git config core.capslock true &&
884 #               hello world
885 #               git config --unset core.capslock
886 #       '
887 #
888 # except that the greeting and config --unset must both succeed for
889 # the test to pass.
890
891 test_when_finished () {
892         test_cleanup="{ $*
893                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
894 }
895
896 test_done () {
897         GIT_EXIT_OK=t
898         test_results_dir="$TEST_DIRECTORY/test-results"
899         mkdir -p "$test_results_dir"
900         test_results_path="$test_results_dir/$this_test"
901
902         echo "total $test_count" >> $test_results_path
903         echo "success $test_success" >> $test_results_path
904         echo "fixed $test_fixed" >> $test_results_path
905         echo "broken $test_broken" >> $test_results_path
906         echo "failed $test_failure" >> $test_results_path
907         echo "" >> $test_results_path
908
909         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
910
911         if [ "$test_failure" = "0" ]; then
912             if [ "$test_broken" = "0" ]; then
913                 rm -rf "$remove_tmp"
914             fi
915             exit 0
916         else
917             exit 1
918         fi
919 }
920
921 emacs_generate_script () {
922         # Construct a little test script here for the benefit of the user,
923         # (who can easily run "run_emacs" to get the same emacs environment
924         # for investigating any failures).
925         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
926 #!/bin/sh
927 export PATH=$PATH
928 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
929
930 # Here's what we are using here:
931 #
932 # --quick              Use minimal customization. This implies --no-init-file,
933 #                      --no-site-file and (emacs 24) --no-site-lisp
934 #
935 # --directory           Ensure that the local elisp sources are found
936 #
937 # --load                Force loading of notmuch.el and test-lib.el
938
939 exec ${TEST_EMACS} --quick \
940         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
941         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
942         "\$@"
943 EOF
944         chmod a+x "$TMP_DIRECTORY/run_emacs"
945 }
946
947 test_emacs () {
948         # test dependencies beforehand to avoid the waiting loop below
949         missing_dependencies=
950         test_require_external_prereq dtach || missing_dependencies=1
951         test_require_external_prereq emacs || missing_dependencies=1
952         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
953         test -z "$missing_dependencies" || return
954
955         if [ -z "$EMACS_SERVER" ]; then
956                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
957                 if [ -f "$emacs_tests" ]; then
958                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
959                 else
960                         load_emacs_tests=
961                 fi
962                 server_name="notmuch-test-suite-$$"
963                 # start a detached session with an emacs server
964                 # user's TERM (or 'vt100' in case user's TERM is known dumb
965                 # or unknown) is given to dtach which assumes a minimally
966                 # VT100-compatible terminal -- and emacs inherits that
967                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
968                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
969                                 --no-window-system \
970                                 $load_emacs_tests \
971                                 --eval '(setq server-name \"$server_name\")' \
972                                 --eval '(server-start)' \
973                                 --eval '(orphan-watchdog $$)'" || return
974                 EMACS_SERVER="$server_name"
975                 # wait until the emacs server is up
976                 until test_emacs '()' >/dev/null 2>/dev/null; do
977                         sleep 1
978                 done
979         fi
980
981         # Clear test-output output file.  Most Emacs tests end with a
982         # call to (test-output).  If the test code fails with an
983         # exception before this call, the output file won't get
984         # updated.  Since we don't want to compare against an output
985         # file from another test, so start out with an empty file.
986         rm -f OUTPUT
987         touch OUTPUT
988
989         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
990 }
991
992 test_python() {
993     # Note: if there is need to print debug information from python program,
994     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
995     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
996         $NOTMUCH_PYTHON -B - > OUTPUT
997 }
998
999 test_ruby() {
1000     MAIL_DIR=$MAIL_DIR ruby -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1001 }
1002
1003 test_C () {
1004     exec_file="test${test_count}"
1005     test_file="${exec_file}.c"
1006     cat > ${test_file}
1007     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1008     echo "== stdout ==" > OUTPUT.stdout
1009     echo "== stderr ==" > OUTPUT.stderr
1010     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1011     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1012 }
1013
1014
1015 # Creates a script that counts how much time it is executed and calls
1016 # notmuch.  $notmuch_counter_command is set to the path to the
1017 # generated script.  Use notmuch_counter_value() function to get the
1018 # current counter value.
1019 notmuch_counter_reset () {
1020         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1021         if [ ! -x "$notmuch_counter_command" ]; then
1022                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1023                 cat >"$notmuch_counter_command" <<EOF || return
1024 #!/bin/sh
1025
1026 read count < "$notmuch_counter_state_path"
1027 echo \$((count + 1)) > "$notmuch_counter_state_path"
1028
1029 exec notmuch "\$@"
1030 EOF
1031                 chmod +x "$notmuch_counter_command" || return
1032         fi
1033
1034         echo 0 > "$notmuch_counter_state_path"
1035 }
1036
1037 # Returns the current notmuch counter value.
1038 notmuch_counter_value () {
1039         if [ -r "$notmuch_counter_state_path" ]; then
1040                 read count < "$notmuch_counter_state_path"
1041         else
1042                 count=0
1043         fi
1044         echo $count
1045 }
1046
1047 test_reset_state_ () {
1048         test -z "$test_init_done_" && test_init_
1049
1050         test_subtest_known_broken_=
1051         test_subtest_missing_external_prereq_=()
1052 }
1053
1054 # called once before the first subtest
1055 test_init_ () {
1056         test_init_done_=t
1057
1058         # skip all tests if there were external prerequisites missing during init
1059         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1060 }
1061
1062
1063 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1064
1065 if [ "${NOTMUCH_GMIME_MAJOR}" = 3 ]; then
1066     test_subtest_broken_gmime_3 () {
1067         test_subtest_known_broken
1068     }
1069     test_subtest_broken_gmime_2 () {
1070         true
1071     }
1072 else
1073     test_subtest_broken_gmime_3 () {
1074         true
1075     }
1076     test_subtest_broken_gmime_2 () {
1077         test_subtest_known_broken
1078     }
1079 fi
1080
1081 emacs_generate_script
1082
1083
1084 # Use -P to resolve symlinks in our working directory so that the cwd
1085 # in subprocesses like git equals our $PWD (for pathname comparisons).
1086 cd -P "$test" || error "Cannot set up test environment"
1087
1088 if test "$verbose" = "t"
1089 then
1090         exec 4>&2 3>&1
1091 else
1092         exec 4>test.output 3>&4
1093 fi
1094
1095 for skp in $NOTMUCH_SKIP_TESTS
1096 do
1097         to_skip=
1098         for skp in $NOTMUCH_SKIP_TESTS
1099         do
1100                 case "$this_test" in
1101                 $skp)
1102                         to_skip=t
1103                         break
1104                 esac
1105                 case "$this_test_bare" in
1106                 $skp)
1107                         to_skip=t
1108                         break
1109                 esac
1110         done
1111         case "$to_skip" in
1112         t)
1113                 say_color skip >&3 "skipping test $this_test altogether"
1114                 say_color skip "skip all tests in $this_test"
1115                 test_done
1116         esac
1117 done
1118
1119 # Provide an implementation of the 'yes' utility
1120 yes () {
1121         if test $# = 0
1122         then
1123                 y=y
1124         else
1125                 y="$*"
1126         fi
1127
1128         while echo "$y"
1129         do
1130                 :
1131         done
1132 }
1133
1134 # Fix some commands on Windows
1135 case $(uname -s) in
1136 *MINGW*)
1137         # Windows has its own (incompatible) sort and find
1138         sort () {
1139                 /usr/bin/sort "$@"
1140         }
1141         find () {
1142                 /usr/bin/find "$@"
1143         }
1144         sum () {
1145                 md5sum "$@"
1146         }
1147         # git sees Windows-style pwd
1148         pwd () {
1149                 builtin pwd -W
1150         }
1151         # no POSIX permissions
1152         # backslashes in pathspec are converted to '/'
1153         # exec does not inherit the PID
1154         ;;
1155 *)
1156         test_set_prereq POSIXPERM
1157         test_set_prereq BSLASHPSPEC
1158         test_set_prereq EXECKEEPSPID
1159         ;;
1160 esac
1161
1162 test -z "$NO_PERL" && test_set_prereq PERL
1163 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1164
1165 # test whether the filesystem supports symbolic links
1166 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1167 rm -f y
1168
1169 # convert variable from configure to more convenient form
1170 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1171     glass)
1172         db_ending=glass
1173     ;;
1174     chert)
1175         db_ending=DB
1176     ;;
1177     *)
1178         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1179 esac
1180 # declare prerequisites for external binaries used in tests
1181 test_declare_external_prereq dtach
1182 test_declare_external_prereq emacs
1183 test_declare_external_prereq ${TEST_EMACSCLIENT}
1184 test_declare_external_prereq ${TEST_GDB}
1185 test_declare_external_prereq gpg
1186 test_declare_external_prereq openssl
1187 test_declare_external_prereq gpgsm
1188 test_declare_external_prereq ${NOTMUCH_PYTHON}